--[[
wav hex opener
by sam (youresam)
]]--

wav = {}

function wav.init()

function b(byte_number, byte_length) --return a number based on 2 or 4 bytes

if byte_length == 2 then
	byte1 = string.byte(string.sub(filestring, byte_number + 1, byte_number + 1))
	byte2 = string.byte(string.sub(filestring, byte_number + 2, byte_number + 2))
	return dec_to_dec2(byte1,byte2)

elseif byte_length == 4 then
	byte1 = string.byte(string.sub(filestring, byte_number + 1, byte_number + 1))
	byte2 = string.byte(string.sub(filestring, byte_number + 2, byte_number + 2))
	byte3 = string.byte(string.sub(filestring, byte_number + 3, byte_number + 3))
	byte4 = string.byte(string.sub(filestring, byte_number + 4, byte_number + 4))
	return dec_to_dec4(byte1,byte2,byte3,byte4)
end
end


function dec_to_dec2(hexvalue1, hexvalue2) --2 bytes...
first_byte = hexvalue1
second_byte = hexvalue2
sample = (second_byte * 256) + first_byte  -- data is little-endian
if sample > 32767  then -- max positive value
  sample = 0 - (65536 - sample)
end
return sample
end

function dec_to_dec4(hexvalue1, hexvalue2, hexvalue3,hexvalue4) --4 bytes, no need to calc negative
sample = (hexvalue4 * 16777216) + (hexvalue3 * 65536) + (hexvalue2 * 256) + hexvalue1  -- data is little-endian
return sample
end

end --wav.init

function wav.load(wav_filename)
wav.filename = wav_filename
file = io.open(wav.filename, "rb")
if file then
filestring = file:read("*all")
file:close()
end

wav.ChunkSize = b(4,4)
wav.Subchunk1ID = b(12,4)
wav.Subchunk1Size = b(16, 4)
if b(20, 2) == 1 then wav.AudioFormat = "PCM" end
wav.NumChannels = b(22,2)
wav.SampleRate = b(24, 4)
wav.ByteRate = b(28,4)
wav.BlockAlign = b(32,2)
wav.BitsPerSample = b(34,2)
wav.Subchunk2Size = b(40,4)

end --wav.load



function wav.calculate(wav_mode, wav_disp_loading, wav_image_width)
wav.mode = wav_mode
wav.disp_loading = wav_disp_loading
wav.image_width = wav_image_width

num1,begin_samples = string.find(filestring, "data")
begin_samples = begin_samples + 4


num_samples = string.len(string.sub(filestring,begin_samples+1)) /2

wav.total_time = num_samples / (b(24, 4) / 1000)

remove_interval = math.floor(num_samples/wav.image_width)
samples = {}
highest_number = 0
if wav.mode == "full" then
wav.percent = -1
for a=1, num_samples-remove_interval, remove_interval do
current_average_total = 0
for c=a, a+remove_interval-1 do
	current_average_total = current_average_total + b(begin_samples+(c*2)-2,2)
end
table.insert(samples,current_average_total/remove_interval)
if math.abs(current_average_total/remove_interval) > highest_number then
	highest_number = math.abs(current_average_total/remove_interval)
end
if math.floor((a/num_samples)*100) ~= wav.percent then
wav.percent = math.floor((a/num_samples)*100)+1
if wav.disp_loading then wav.display() end
end
end

elseif wav.mode == "quick" then

wav.percent = -1
for a=1, num_samples, remove_interval do
to_add = b(begin_samples+(a*2)-2,2)
table.insert(samples,to_add)
if math.abs(to_add) > highest_number then
	highest_number = math.abs(to_add)
end
if math.floor((a/num_samples)*100) ~= wav.percent then
wav.percent = math.floor((a/num_samples)*100)+1
if wav.disp_loading then wav.display() end
end
end

end --wav.mode
end --wav.calculate

function wav.calculate_image(wav_image_width,wav_image_height,wav_image_bg,wav_image_line,wav_divide_by)
wav.image_width = wav_image_width
wav.image_height = wav_image_height
wav.image_bg = wav_image_bg
wav.image_line = wav_image_line
--//wav.divide_by = wav_divide_by
waves = Image.createEmpty(wav.image_width,wav.image_height)
waves:clear(wav.image_bg)
	--//divide_by = wav.divide_by --75
oldpoint = 0
count = 0
for a=1, table.getn(samples) do


newpoint = (samples[a]/ 32767) * (( .75* (wav.image_height/2))/(highest_number / 32767))

waves:drawLine(count-1, oldpoint+(wav_image_height/2)-1, count, newpoint+(wav_image_height/2)-1, wav.image_line)
oldpoint = newpoint
count = count + 1
end

return waves

end --wav.calculate_image

