--[[
LuaMainframe is the work of Alex Glynn, alexglynn@gmail.com (AKA, Glynnder)
http://www.pspro.co.uk
Copyright, Alex Glynn.
]]

-- default options
options = { navspeed = 1, autoscroll = "true", netlib = "false", wavlib = "false", bmplib = "false", diskmode = "false", start2quit="true", lowbattpercent = 3, overclock = "off", xmbexit = "true", skin = "blue" }

-- possible options for menu
possibleOptions = {
  navspeed = {
    displayName = "NavSpeed",
    values = { 1, 3, 5, 9 } },
  autoscroll = {
    displayName = "Auto-Scroll",
    values = { "true", "false" } },
  netlib = {
    displayName = "Load Netlib",
    values = { "true", "false" } },
  wavlib = {
    displayName = "Load Wavlib",
    values = { "true", "false" } },
  bmplib = {
    displayName = "Load bmplib",
    values = { "true", "false" } },  
  diskmode = {
    displayName = "USB at start",
    values = { "true", "false" } },
  start2quit = {
    displayName = "Start to restart?",
    values = { "true", "false" } },
  lowbattpercent = {
    displayName = "Low battery %",
    values = { 1, 3, 5, 9 } },
  overclock = {
    displayName = "Overclock PSP?",
    values = { "off", "222", "266", "333" } },
  xmbexit = {
    displayName = "Sel = XMB",
    values = { "true", "false" } },
  skin = {
    displayName = "Skin",
    values = { "blue", "green", "red", "white" } }
}

if skin == blue then
backgroundimage = Image.load("image/blue/sysbg.png")
elseif skin == red then
backgroundimage = Image.load("image/rd/sysbg.png")
elseif skin == green then
backgroundimage = Image.load("image/grn/sysbg.png")
elseif skin == white then
backgroundimage = Image.load("image/wht/sysbg.png")
end

selectedOptionNumber = 0
oldPad = Controls.read()

function showMenu()
  deactiveColor = Color.new(0, 0, 0)
  activeColor = Color.new(0, 0, 255)
  x0 = 210
  y0 = 60
  black = Color.new(0, 0, 0)
  y = 0
  selectedOptionValues = nil
  selectedOptionIndex = nil
  selectedOptionName = nil
  for optionKey, possibleOption in pairs(possibleOptions) do
    color = deactiveColor
    if selectedOptionNumber == y then
      color = activeColor
      selectedOptionValues = possibleOption.values
    end
    screen:print(x0 - 180, y * 10 + y0 + 60, possibleOption.displayName, color)
    for i, value in ipairs(possibleOption.values) do
      color = deactiveColor
      if options[optionKey] == value then
        color = activeColor
        if selectedOptionNumber == y then
          selectedOptionIndex = i
          selectedOptionName = optionKey
        end
      end
      screen:print(i * 80 + 100, y * 10 + y0 + 60, value, color)
    end
    y = y + 1
  end

  pad = Controls.read()
  if pad ~= oldPad then
    if pad:circle() then saveOptions() end
    if pad:cross() then return false end
    if pad:up() then
      selectedOptionNumber = selectedOptionNumber - 1
      if selectedOptionNumber < 0 then selectedOptionNumber = y - 1 end
    end
    if pad:down() then
      selectedOptionNumber = selectedOptionNumber + 1
      if selectedOptionNumber >= y then selectedOptionNumber = 0 end
    end
    len = table.getn(selectedOptionValues)
    if pad:left() then
      selectedOptionIndex = selectedOptionIndex - 1
      if selectedOptionIndex <= 0 then selectedOptionIndex = len end
      options[selectedOptionName] = selectedOptionValues[selectedOptionIndex]
    end
    if pad:right() then
      selectedOptionIndex = selectedOptionIndex + 1
      if selectedOptionIndex > len then selectedOptionIndex = 1 end
      options[selectedOptionName] = selectedOptionValues[selectedOptionIndex]
    end
    oldPad = pad
  end
  return true
end

optionsFile = "options.txt"

function saveOptions()
  file = io.open(optionsFile, "w")
  if file then
    for key, value in pairs(options) do
      file:write(key .. "=" .. value .. "\n")
    end
    file:close()
  end
end

while true do
screen:blit(0,0, backgroundimage)

-- remaining time module

time = System.powerGetBatteryLifeTime()
hours = time/60
min = math.mod(time,60)
secs = min/60
hours = hours-secs
if hours < 10 then
hours = "0" .. hours
end
if min < 10 then
min = "0" .. min
end
-- end of remaing time module

      datef = os.date("*t", os.time())
      f = function(s) 
        if s < 10 then
          return "0"..s
        else return s end
      end     
      screen:print(310, 4, f(datef.hour)..":"..f(datef.min)..":"..f(datef.sec))
  
        screen:print(445, 4, tostring("".. System.powerGetBatteryLifePercent()) .. "%")

showMenu()
  
if  (System.powerGetBatteryLifePercent()) <= lowbattpercent then
lowbatt = true
end
if lowbatt == true then
screen:fontPrint(proportionalBig, 50, 150, "Low Battery", white)
lowbatt = false
else
end  

pad = Controls.read()
if pad:square() then
      System.currentDirectory(appsDir .. "/interfaceLua")
      dofile("home.lua")
      break
  end
  if start2quit == true then
  if pad:start() then
  System.usbDiskModeDeactivate()
  break
  end
  end
  if pad:r() then dofavehb = true end
  if dofavehb == true then
  dirbkup = System.currentDirectory()
  System.currentDirectory(hbdir)
  dofile(hbloc)
  dofavehb = false
  end
  if dofavehb == false then
  System.currentDirectory(dirbkup)
  end
  screen:blit(X, Y, circle)
  if pad:l() then diskmode = true end
  if diskmode== true then
  System.usbDiskModeActivate()
  screen:blit(4,2, active)
  
  diskmodekey = Controls.read()
  if diskmodekey:l() then
  diskmode = false
  end
  else
  System.usbDiskModeDeactivate()
  end
      screen:flip()  
end 